%define major       3.0

%define libname     %mklibname %{name} %{major}
%define develname   %mklibname %{name} -d

# build an efi boot image (where supported) unless rpmbuild was run with
# --without efi
%define build_efi %{?_without_efi: 0} %{?!_without_efi: 1}
# xen only supports efi boot images on x86_64
%ifnarch x86_64
%define build_efi 0
%endif

Name:       xen
Version:    4.6.5
Release:    %mkrel 2
Summary:    The basic tools for managing Xen virtual machines
Group:      System/Kernel and hardware
License:    GPL
URL:        http://xen.org/
Source0:    http://bits.xensource.com/oss-xen/release/%{version}/xen-%{version}.tar.gz
Source2:    %{name}.logrotate
# used by stubdoms
# (from http://xenbits.xen.org/xen-extfiles/):
Source10:   http://xenbits.xen.org/xen-extfiles/lwip-1.3.0.tar.gz
Source11:   http://xenbits.xen.org/xen-extfiles/newlib-1.16.0.tar.gz
Source12:   http://xenbits.xen.org/xen-extfiles/zlib-1.2.3.tar.gz
Source13:   http://xenbits.xen.org/xen-extfiles/pciutils-2.2.9.tar.bz2
Source14:   http://xenbits.xen.org/xen-extfiles/grub-0.97.tar.gz
Source15:   http://xenbits.xen.org/xen-extfiles/polarssl-1.1.4-gpl.tgz

# Fedora patches:
Patch5: xen-net-disable-iptables-on-bridge.patch

Patch11: xen.use.fedora.ipxe.patch
Patch12: xen.fedora.efi.build.patch
Patch13: xen.xsm.enable.patch
# only used on FC when cross-compiling:
%if 0
Patch14: xen.64.bit.hyp.on.ix86.patch
%endif
Patch15: CVE-2014-0150.patch
Patch16: xen.fedora.systemd.patch
Patch17: xen.ocaml.selinux.fix.patch
Patch18: xen.gcc5.fix.patch
Patch20: xen.fedora.crypt.patch
Patch21: qemu.trad.CVE-2015-6815.patch
Patch22: qemu.trad.CVE-2015-5279.patch
Patch23: qemu.trad.CVE-2015-5278.patch
Patch24: qemu.git-7882080388be5088e72c425b02223c02e6cb4295.patch
Patch25: qemu.git-d9033e1d3aa666c5071580617a57bd853c5d794a.patch
Patch26: qemu.git-ce317461573bac12b10d67699b4ddf1f97cf066c.patch
Patch27: qemu.git-29b9f5efd78ae0f9cc02dd169b6e80d2c404bade.patch
Patch28: qemu.git-0cf33fb6b49a19de32859e2cdc6021334f448fb3.patch
Patch29: qemu.trad.CVE-2015-7295.patch
Patch46: qemu.git-00837731d254908a841d69298a4f9f077babaf24.patch
Patch49: qemu.trad.CVE-2015-8345.patch
Patch50: qemu.trad.CVE-2015-7512.patch
Patch51: qemu.trad.CVE-2015-8504.patch
Patch66: qemu.git-43b11a91dd861a946b231b89b754285.patch
Patch68: qemu.git-d9a3b33d2c9f996537b7f1d0246dee2d0120cefb.patch
Patch69: qemu.git-a7278b36fcab9af469563bd7b.patch
Patch70: qemu.git-c6048f849c7e3f009786df76206e895.patch
Patch73: xen.gcc6.fix.patch
Patch76: qemu.trad.CVE-2016-1714.patch
Patch77: qemu.CVE-2016-1922.patch
Patch80: qemu.trad.CVE-2016-1981.patch
Patch82: qemu.CVE-2016-2198.patch
Patch83: qemu.CVE-2016-2841.patch
Patch84: qemu.trad.CVE-2016-2841.patch
Patch85: qemu.CVE-2016-2538.patch
Patch86: qemu.trad.CVE-2016-2538.patch
Patch87: qemu.CVE-2016-2392.patch
Patch88: qemu.CVE-2016-2391.patch
Patch89: qemu.CVE-2016-2857.patch
Patch90: qemu.trad.CVE-2016-2857.patch
Patch91: qemu.CVE-2015-8817+8.patch
Patch93: xen.glibc.fix.patch
Patch96: qemu.git-3a15cc0e1ee7168db0782133d2607a6bfa422d66.patch
Patch97: qemu.trad.CVE-2016-4001.patch
Patch98: qemu.CVE-2016-4002.patch
Patch99: qemu.trad.CVE-2016-4002.patch
Patch100: qemu.CVE-2016-4037.patch
Patch101: qemu.bug1330513.patch
Patch116: qemu.CVE-2016-4439.patch
Patch117: qemu.trad.CVE-2016-4439.patch
Patch118: qemu.CVE-2016-4441.patch
Patch119: qemu.trad.CVE-2016-4441.patch
Patch120: qemu.CVE-2016-5106.patch
Patch121: qemu.CVE-2016-5105.patch
Patch122: qemu.git-3c52ddcdc548e7fbe65112d8a7bdc9cd105b4750.patch
Patch123: qemu.git-74074e8a7c60592cf1cc6469dbc2550d24aeded3.patch
Patch124: qemu.git-9f14b0add1dcdbfa2ee61051d068211fb0a1fcc9.patch
Patch125: qemu.git-60253ed1e6ec6d8e5ef2efe7bf755f475dce9956.patch
Patch156: qemu.CVE-2016-4454.1.patch
Patch157: qemu.CVE-2016-4454.2.patch
Patch158: qemu.CVE-2016-4454.3.patch
Patch159: qemu.CVE-2016-4453.patch
Patch160: qemu.CVE-2016-5238.patch
Patch161: qemu.trad.CVE-2016-5238.patch
Patch163: qemu.CVE-2016-5338.patch
Patch164: qemu.trad.CVE-2016-5338.patch
Patch165: qemu.CVE-2016-5337.patch
Patch166: xen.xs_watch.stacksize.patch
Patch171: qemu.git-926cde5f3e4d2504ed161ed0.patch
Patch172: qemu.git-cc96677469388bad3d664793.patch
Patch173: qemu.trad.CVE-2016-6351.patch
Patch178: qemu.git-fff39a7ad09da07ef490de05c92c91f22f8002f2.patch
Patch179: qemu.git-805b5d98c649d26fc44d2d7755a97f18e62b438a.patch
Patch180: qemu.git-56f101ecce0eafd09e2daf1c4eeb1377d6959261.patch
Patch181: qemu.git-a0d1cbdacff5df4ded16b753b38fdd9da6092968.patch
Patch183: qemu.git-05f43d44e4bc26611ce25fd7d726e483f73363ce.patch
Patch184: qemu.git-e95c9a493a5a8d6f969e86c9f19f80ffe6587e19.patch
Patch185: qemu.git-ba42ebb863ab7d40adc79298422ed9596df8f73a.patch
Patch186: qemu.git-3592fe0c919cf27a81d8e9f9b4f269553418bb01.patch
Patch187: qemu.trad.CVE-2016-8669.patch
Patch188: qemu.git-c7c35916692fe010fef25ac338443d3fe40be225.patch
Patch189: qemu.trad.CVE-2016-8910.patch
Patch190: qemu.git-6be8f5e2626e102433e569d9cece2120baf0c879.patch
Patch191: qemu.git-eb687602853b4ae656e9236ee4222609f3a6887d.patch
Patch192: qemu.git-ff55e94d23ae94c8628b0115320157c763eb3e06.patch
Patch193: qemu.git-4c1586787ff43c9acd18a56c12d720e3e6be9f7c.patch
Patch194: qemu.git-fdfcc9aeea1492f4b819a24c94dfb678145b1bf9.patch
Patch195: qemu.bug1389686.patch
Patch209: qemu.git-4299b90e9ba9ce5ca9024572804ba751aa1a7e70.patch
Patch210: qemu.trad.bug1399055.patch
Patch211: qemu.git-4774718e5c194026ba5ee7a28d9be49be3080e42.patch
Patch212: qemu.git-702dbcc274e2ca43be20ba64c758c0ca57dab91d.patch
Patch213: qemu.git-971f406b77a6eb84e0ad27dcc416b663765aee30.patch
Patch214: qemu.git-898ae90a44551d25b8e956fd87372d303c82fe68.patch
Patch220: qemu.git-77d54985b85a0cb760330ec2bd92505e0a2a97a9.patch
Patch221: qemu.trad.CVE-2016-9776.patch
Patch222: qemu.git-12351a91da97b414eec8cdb09f1d9f41e535a401.patch
# (tmb) broken patch
%if 0
Patch223: qemu.git-069eb7b2b8fc47c7cb52e5a4af23ea98d939e3da.patch
%endif
Patch224: xsa211-qemut.patch
Patch225: xsa211-qemuu-4.6.patch
Patch226: qemu.git-95ed56939eb2eaa4e2f349fe6dcd13ca4edfd8fb.patch
Patch227: qemu.trad.CVE-2017-6505.patch
Patch228: xsa206-4.60001-xenstored-apply-a-write-transaction-rate-limit.patch
Patch229: xsa206-4.60002-xenstored-Log-when-the-write-transaction-rate-limit-.patch
Patch230: xsa206-4.60003-oxenstored-refactor-putting-response-on-wire.patch
Patch231: xsa206-4.60004-oxenstored-remove-some-unused-parameters.patch
Patch232: xsa206-4.60005-oxenstored-refactor-request-processing.patch
Patch233: xsa206-4.60006-oxenstored-keep-track-of-each-transaction-s-operatio.patch
Patch234: xsa206-4.60007-oxenstored-move-functions-that-process-simple-operat.patch
Patch235: xsa206-4.60008-oxenstored-replay-transaction-upon-conflict.patch
Patch236: xsa206-4.60009-oxenstored-log-request-and-response-during-transacti.patch
Patch237: xsa206-4.60010-oxenstored-allow-compilation-prior-to-OCaml-3.12.0.patch
Patch238: xsa206-4.60011-oxenstored-comments-explaining-some-variables.patch
Patch239: xsa206-4.60012-oxenstored-handling-of-domain-conflict-credit.patch
Patch240: xsa206-4.60013-oxenstored-ignore-domains-with-no-conflict-credit.patch
Patch241: xsa206-4.60014-oxenstored-add-transaction-info-relevant-to-history-.patch
Patch242: xsa206-4.60015-oxenstored-support-commit-history-tracking.patch
Patch243: xsa206-4.60016-oxenstored-only-record-operations-with-side-effects-.patch
Patch244: xsa206-4.60017-oxenstored-discard-old-commit-history-on-txn-end.patch
Patch245: xsa206-4.60018-oxenstored-track-commit-history.patch
Patch246: xsa206-4.60019-oxenstored-blame-the-connection-that-caused-a-transa.patch
Patch247: xsa206-4.60020-oxenstored-allow-self-conflicts.patch
Patch248: xsa206-4.60021-oxenstored-do-not-commit-read-only-transactions.patch
Patch249: xsa206-4.60022-oxenstored-don-t-wake-to-issue-no-conflict-credit.patch
Patch250: xsa206-4.60023-oxenstored-transaction-conflicts-improve-logging.patch
Patch251: xsa206-4.60024-oxenstored-trim-history-in-the-frequent_ops-function.patch
Patch252: qemu.git-d63fb193e71644a073b77ff5ac6f1216f2f6cf6e.patch
Patch253: xsa212.patch
Patch254: xsa213-4.6.patch
Patch255: xsa214.patch
Patch256: xsa215.patch
Patch257: xsa216-qemuu-4.7.patch
Patch258: xsa217.patch
Patch259: xsa218-0001-IOMMU-handle-IOMMU-mapping-and-unmapping-failures.patch
Patch260: xsa218-0002-gnttab-fix-unmap-pin-accounting-race.patch
Patch261: xsa218-0003-gnttab-Avoid-potential-double-put-of-maptrack-entry.patch
Patch262: xsa218-0004-gnttab-correct-maptrack-table-accesses.patch
Patch263: xsa219-4.6.patch
Patch264: xsa220-4.6.patch
Patch265: xsa221.patch
Patch266: xsa222-1-4.6.patch
Patch267: xsa222-2-4.6.patch
Patch268: xsa223.patch
Patch269: xsa224-0001-gnttab-Fix-handling-of-dev_bus_addr-during-unmap.patch
Patch270: xsa224-0002-gnttab-never-create-host-mapping-unless-asked-to.patch
Patch271: xsa224-0003-gnttab-correct-logic-to-get-page-references-during-m.patch
Patch272: xsa224-0004-gnttab-__gnttab_unmap_common_complete-is-all-or-noth.patch
Patch273: xsa225.patch

# Mageia patches:
Patch201:   xen-4.1.2-fix-stubdom-Makefile.patch
Patch202:   xen-4.1.3-fix-doc-build.patch
Patch203:   xen-4.2.1-fix-glibc-build.patch
Patch204:   xen-4.2-ocaml-build.patch

BuildRequires: transfig libidn-devel zlib-devel texi2html SDL-devel curl-devel
BuildRequires:  libx11-devel, python-devel, ghostscript, tetex-latex
BuildRequires:  ncurses-devel gtk2-devel libaio-devel
# for the docs
BuildRequires: perl perl(Pod::Man) perl(Pod::Text) texinfo graphviz
# optional requires for more documentation
BuildRequires: discount
%ifarch %{ix86} x86_64
# for the VMX "bios"
BuildRequires:  dev86-devel
%endif
BuildRequires:  gettext
BuildRequires:  gnutls-devel
BuildRequires:	libgcrypt-devel
BuildRequires:  brlapi-devel
BuildRequires:  openssl-devel
# For ioemu PCI passthrough
BuildRequires:  pciutils-devel
# Several tools now use uuid
BuildRequires:  libuuid-devel
# iasl needed to build hvmloader
BuildRequires: iasl
# build using Fedora seabios and ipxe packages for roms
BuildRequires: seabios-bin ipxe-roms-qemu
# for spice support
BuildRequires:	spice-server-devel
BuildRequires:	spice-protocol
BuildRequires:	pkgconfig(libusbredirparser-0.5) >= 0.6
# modern compressed kernels
BuildRequires: bzip2-devel xz-devel
# libfsimage
BuildRequires: e2fsprogs-devel
# tools now require yajl and wget
BuildRequires: yajl-devel wget
# remus support now needs libnl3
BuildRequires: libnl3-devel
# for virtfs support
BuildRequires:	attr-devel
BuildRequires:	cap-devel
Requires:   bridge-utils
Requires:   glibc-xen
Requires:   grub
Requires:   iptables
Requires:   kernel-server
Requires:   kmod
Requires:   python
Requires:   python-lxml
Requires:   %{libname} = %{version}-%{release}
Requires:   xen-hypervisor = %{version}
ExclusiveArch: %{ix86} x86_64
BuildRequires: ocaml, ocaml-findlib-devel
Requires(post):  systemd >= %{systemd_required_version}
Requires(post):  rpm-helper
Requires(preun): rpm-helper
# efi image needs an ld that has -mi386pep option
%if %build_efi
BuildRequires: mingw64-binutils
%endif
BuildRequires:	systemd-devel
Requires: qemu qemu-img


%description 
The basic tools for managing Xen virtual machines.

%package -n ocaml-xen
Summary: Ocaml bindings for Xen
Group: Development/Other

%description -n ocaml-xen
This package contains the Ocaml bindings for Xen

%package -n ocaml-xen-devel
Summary: Static libraries and header files for Ocaml bindings for Xen
Group: Development/Other
Requires: %{name}-devel = %{version}-%{release}

%description -n ocaml-xen-devel
This package contains the libraries and headers needed only to compile
applications linked on Ocaml bindings for Xen.

%package hypervisor
Summary: Libraries for Xen tools
Group: System/Kernel and hardware

%description hypervisor
This package contains the Xen hypervisor


%package doc
Summary:    Xen documentation
Group:      Documentation

%description doc
This package contains the Xen documentation.

%package -n %{libname}
Summary:    Libraries for %{name}
Group:      System/Libraries
Conflicts:  %{name} < 3.1.0-5

%description -n %{libname}
This package contains the libraries needed to run programs dynamically
linked with Xen libraries.

%package -n %{develname}
Summary:    Static libraries and header files for %{name}
Group:      Development/C
Requires:   %{libname} = %{version}-%{release}
Provides:   %{name}-devel = %{version}-%{release}
Conflicts:  %{name} < 3.1.0-5

%description -n %{develname}
This package contains the static development libraries and headers needed
to compile applications linked with Xen libraries.

%prep
%setup -q
%autopatch -p1

# stubdom sources
cp -v %{SOURCE10} %{SOURCE11} %{SOURCE12} %{SOURCE13} %{SOURCE14} %{SOURCE15} stubdom

%build
sed -E -i 's/(as_fn_error \$\? "cannot find wget or ftp" "\$LINENO" 5)/as_fn_status $?/' tools/configure
sed -E -i 's/(as_fn_error \$\? "cannot find wget or ftp" "\$LINENO" 5)/as_fn_status $?/' stubdom/configure

%if %build_efi
%define efi_flags LD_EFI=/usr/x86_64-w64-mingw32/bin/ld
mkdir -p dist/install/boot/efi/efi/fedora
%endif
%if %(test -f /usr/share/seabios/bios-256k.bin && echo 1|| echo 0)
%define seabiosloc /usr/share/seabios/bios-256k.bin
%else
%define seabiosloc /usr/share/seabios/bios.bin
%endif
export CFLAGS="$RPM_OPT_FLAGS"
%ifnarch %{ix86}
make %{?_smp_mflags} %{?efi_flags} prefix=/usr dist-xen
%endif

./configure --build=%{_target_platform} \
        --with-system-seabios=%{seabiosloc} \
        --with-extra-qemuu-configure-args="--enable-spice --enable-usb-redir --enable-virtfs" \
        --prefix=%{_prefix} \
        --exec-prefix=%{_exec_prefix} \
        --bindir=%{_bindir} \
        --sbindir=%{_sbindir} \
        --sysconfdir=%{_sysconfdir} \
        --datadir=%{_datadir} \
        --includedir=%{_includedir} \
        --libdir=%{_libdir} \
        --libexecdir=%{_libexecdir} \
        --localstatedir=%{_localstatedir} \
        --sharedstatedir=%{_sharedstatedir} \
        --mandir=%{_mandir} \
        --infodir=%{_infodir}
make %{?_smp_mflags} %{?ocaml_flags} prefix=/usr dist-tools
make  prefix=/usr dist-docs
unset CFLAGS
make dist-stubdom

%install
mkdir -p %{buildroot}%{_libdir}/ocaml/stublibs
%if %build_efi
mkdir -p %{buildroot}/boot/efi/efi/fedora
%endif
%ifarch %{ix86}
cat > README.install.urpmi <<_EOF
Since xen 4.3, the hypervisor is no longer supported on x86_32. But fear not,
you can actually use the x86_64 xen hypervisor, even when using a 32bit kernel
and system. This is because the hypervisor is loaded before the kernel and OS.
Keep in mind that a x86_64 capable processor is still required, but then if
you are installing a hypervisor, you really should be using 64bit anyway.
_EOF
ln README.install.urpmi README.4.3.0.upgrade.urpmi
%else
make DESTDIR=%{buildroot} %{?efi_flags} prefix=/usr install-xen
%endif

make DESTDIR=%{buildroot} %{?ocaml_flags} prefix=/usr install-tools
make DESTDIR=%{buildroot} prefix=/usr install-docs
make DESTDIR=%{buildroot} %{?ocaml_flags} prefix=/usr install-stubdom
%if %build_efi
mv %{buildroot}/boot/efi/efi %{buildroot}/boot/efi/EFI
%endif

############ kill unwanted stuff ############

# stubdom: newlib
rm -rf %{buildroot}/usr/*-xen-elf

# Pointless helper
rm -f %{buildroot}%{_sbindir}/xen-python-path

# qemu stuff (unused or available from upstream)
rm -rf %{buildroot}/usr/share/xen/man
rm -rf %{buildroot}/usr/bin/qemu-*-xen
ln -s qemu-img %{buildroot}/%{_bindir}/qemu-img-xen
ln -s qemu-img %{buildroot}/%{_bindir}/qemu-nbd-xen
for file in bios.bin openbios-sparc32 openbios-sparc64 ppc_rom.bin \
         pxe-e1000.bin pxe-ne2k_pci.bin pxe-pcnet.bin pxe-rtl8139.bin \
         vgabios.bin vgabios-cirrus.bin video.x openbios-ppc bamboo.dtb
do
	rm -f %{buildroot}/%{_datadir}/xen/qemu/$file
done

# README's not intended for end users
rm -f %{buildroot}/%{_sysconfdir}/xen/README*

# standard gnu info files
rm -rf %{buildroot}/usr/info

# adhere to Static Library Packaging Guidelines
rm -rf %{buildroot}/%{_libdir}/*.a

%if %build_efi
# clean up extra efi files
rm -rf %{buildroot}/%{_libdir}/efi
%endif

# logrotate
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d/
install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

# init scripts
rm %{buildroot}%{_sysconfdir}/rc.d/init.d/xen-watchdog
rm %{buildroot}%{_sysconfdir}/rc.d/init.d/xencommons
rm %{buildroot}%{_sysconfdir}/rc.d/init.d/xendomains

############ create dirs in /var ############

mkdir -p %{buildroot}%{_localstatedir}/lib/xen/images
mkdir -p %{buildroot}%{_localstatedir}/log/xen/console

# no selinux support
sed -i -E '/^Options=/ s/,context=".*?"//' %{buildroot}%{_unitdir}/var-lib-xenstored.mount

# gprintify has a bug handling some constructs in xendomain
export DONT_GPRINTIFY=1


%if %build_efi
pushd %{buildroot}/boot/
mv efi/EFI/{fedora,mageia}
mv efi EFI
popd
%endif

rm -fr %{buildroot}/usr/share/locale/*/LC_MESSAGES/qemu.mo

%post
%_post_service xen-init-dom0
%_post_service xen-qemu-dom0-disk-backend
%_post_service xenstored
%_post_service xenconsoled
%_post_service xendomains

%preun
%_preun_service xendomains
%_preun_service xenconsoled
%_preun_service xenstored
%_preun_service xen-qemu-dom0-disk-backend
%_preun_service xen-init-dom0

%files
%dir %{_docdir}/%{name}
%doc README
%{_sysconfdir}/bash_completion.d/xl.sh
%dir %{_sysconfdir}/xen
%{_sysconfdir}/xen/scripts
%{_sysconfdir}/xen/auto
%config(noreplace) %{_sysconfdir}/xen/xlexample*
%config(noreplace) %{_sysconfdir}/xen/cpupool
%config(noreplace) %{_sysconfdir}/xen/xl.conf
%config(noreplace) %{_sysconfdir}/xen/oxenstored.conf
%{_mandir}/man*/*
%{_libexecdir}/xen
%{_libdir}/fs
%{_datadir}/qemu-xen/
%exclude /usr/libexec/qemu-bridge-helper
/usr/etc/qemu/target-x86_64.conf
%{py_platsitedir}/xen
%{py_platsitedir}/grub/*
%{py_platsitedir}/fsimage.so
%{py_platsitedir}/pygrub-0.3-py%{pyver}.egg-info
%{py_platsitedir}/xen-3.0-py%{pyver}.egg-info
%{_datadir}/xen
%{_localstatedir}/log/xen
%{_localstatedir}/log/xen/console
# general xen state
%{_localstatedir}/lib/xen
/usr/lib/modules-load.d/xen.conf
%{_unitdir}/oxenstored.service
%{_sysconfdir}/rc.d/init.d/xendriverdomain
%{_unitdir}/proc-xen.mount
%{_unitdir}/var-lib-xenstored.mount
%{_unitdir}/xenstored.service
%{_unitdir}/xenconsoled.service
%{_unitdir}/xen-watchdog.service
%{_unitdir}/xendomains.service
%{_unitdir}/xen-qemu-dom0-disk-backend.service
%{_unitdir}/xenstored_ro.socket
%{_unitdir}/xenstored.socket
%config(noreplace) %{_sysconfdir}/sysconfig/xendomains
%config(noreplace) %{_sysconfdir}/sysconfig/xencommons
%config(noreplace) %{_sysconfdir}/logrotate.d/xen
%{_sbindir}/xenstored
%{_sbindir}/xenconsoled
%{_sbindir}/xentop
%{_sbindir}/xen-bugtool
%{_sbindir}/xenbaked
%{_sbindir}/xenmon.py
%{_sbindir}/img2qcow
%{_sbindir}/flask-*
%{_sbindir}/qcow-create
%{_sbindir}/qcow2raw
%{_sbindir}/xentrace_setmask
%{_sbindir}/xencov
%{_sbindir}/xenperf
%{_sbindir}/xenpm
%{_sbindir}/xenpmd
%{_sbindir}/gtracestat
%{_sbindir}/gtraceview
%{_sbindir}/lock-util
%{_sbindir}/tapdisk-client
%{_sbindir}/tapdisk-diff
%{_sbindir}/tapdisk-stream
%{_sbindir}/tapdisk2
%{_sbindir}/td-util
%{_sbindir}/vhd-update
%{_sbindir}/vhd-util
%{_sbindir}/xen-hvmctx
%{_sbindir}/xen-tmem-list-parse
%{_sbindir}/xenlockprof
%{_sbindir}/xen-lowmemd
%{_sbindir}/xen-ringwatch
%{_sbindir}/xl
%{_sbindir}/gdbsx
%{_sbindir}/kdd
%{_sbindir}/oxenstored
%{_sbindir}/tap-ctl
%{_sbindir}/xen-hptool
%{_sbindir}/xen-hvmcrash
%{_sbindir}/xen-mfndump
%{_sbindir}/xentrace
%{_sbindir}/xentrace_setsize
%{_sbindir}/xenwatchdogd
%{_bindir}/xenalyze
%{_bindir}/xencons
%{_bindir}/xencov_split
%{_bindir}/xentrace_format
%{_bindir}/xenstore-*
%{_bindir}/pygrub
%{_bindir}/xen-detect
%{_bindir}/qemu-img-xen
%{_bindir}/qemu-nbd-xen
%{_bindir}/xenstore

%files -n ocaml-xen
%exclude %{_libdir}/ocaml/*/*.a
%exclude %{_libdir}/ocaml/*/*.cmxa
%exclude %{_libdir}/ocaml/*/*.cmx
%{_libdir}/ocaml/*

%files -n ocaml-xen-devel
%{_libdir}/ocaml/*/*.a
%{_libdir}/ocaml/*/*.cmxa
%{_libdir}/ocaml/*/*.cmx

%files hypervisor
%ifarch %{ix86}
%doc README.4.3.0.upgrade.urpmi README.install.urpmi
%else
/boot/xen-*.gz
/boot/xen.gz
%endif
%if %build_efi
/boot/EFI/EFI/mageia/*.efi
%endif

%files doc
%{_docdir}/%{name}/*
%doc docs/txt/* docs/html/*

%files -n %{libname}
%{_libdir}/*.so.*

%files -n %{develname}
%{_includedir}/xen
%{_includedir}/xenstore-compat
%{_includedir}/*.h
%{_libdir}/*.so
/usr/share/pkgconfig/*


%changelog
* Tue Jun 20 2017 tmb <tmb> 4.6.5-2.mga6
+ Revision: 1107965
- fix XSA-216 to XSA-225

* Sun Jun 04 2017 tmb <tmb> 4.6.5-1.mga6
+ Revision: 1106636
- sync with Fedora 4.6.5-6 (fixes all security issues up to XSA-215)

* Mon Sep 26 2016 pterjan <pterjan> 4.6.1-8.mga6
+ Revision: 1056531
- Rebuild for fix in ocaml

* Thu Jun 16 2016 daviddavid <daviddavid> 4.6.1-7.mga6
+ Revision: 1021767
- add patch from fedora to fix build with new systemd

* Fri May 13 2016 tv <tv> 4.6.1-6.mga6
+ Revision: 1014808
- sync patches with FC

* Thu Apr 21 2016 tv <tv> 4.6.1-5.mga6
+ Revision: 1004111
- adjust file list
- disable patch 92 again and explain why I had disabled it in the first place :-)
- do apply patch 92
- sync CVE patches with FC
- do not include qemu language files

* Mon Apr 18 2016 tv <tv> 4.6.1-4.mga6
+ Revision: 1003363
- use %%doc
- do not reinvent %%doc
- drop static libs
- requires qemu & drop ROMs already packaged
- xen support is in 256k seabios binary when it exists
- build an efi boot image where it is supported

* Mon Apr 11 2016 alien <alien> 4.6.1-2.mga6
+ Revision: 1000425
- Fixed xenstored mount by turning off selinux support

  + tv <tv>
    - remove unused BR
    - kill old obsolete tags
    - add some BRs for doc

* Sun Apr 03 2016 tv <tv> 4.6.1-1.mga6
+ Revision: 997741
- new release
- sync patches with FC
- drop merged patches
- adjust file list
- the project name is "Xen", not "XEN"

  + tmb <tmb>
    - vnc/tls: don't use depricated gnutls functions
    - vnc/tls: Fix compilation with newer versions of GNU-TLS
    - sync in upstream fixes from upstream stable 4.5 branch
    - PV superpage functionality missing sanity checks
      (XSA167 / CVE-2016-1570)
    - VMX: intercept issue with INVLPG on non-canonical address
      (XSA-168 / CVE-2016-1571)

  + luigiwalser <luigiwalser>
    - rebuild for gnutls

  + blino <blino>
    - buildrequire spice and usbredirparser on ARM as well

* Tue Jan 05 2016 neoclust <neoclust> 4.5.2-6.mga6
+ Revision: 919848
- Do not build xen on ARM

* Thu Dec 24 2015 tmb <tmb> 4.5.2-5.mga6
+ Revision: 914470
- paravirtualized drivers incautious about shared memory contents
  (CVE-2015-8550 / XSA-155)

* Thu Dec 24 2015 tmb <tmb> 4.5.2-4.mga6
+ Revision: 914226
- memory: split and tighten maximum order permitted in memops
  (CVE-2015-8338 / XSA-158)
- memory: fix XENMEM_exchange error handling
  (CVE-2015-8339 + CVE-2015-8340 / XSA-159)
- libxl: Fix bootloader-related virtual memory leak on pv build failure
- x86/PoD: Make p2m_pod_empty_cache() restartable
- x86/vmx: improvements to vmentry failure handling
- x86/HVM: don't inject #DB with error code
- VMX: fix/adjust trap injection
- sched: fix locking for insert_vcpu() in credit1 and RTDS
- x86/vPMU: document as unsupported (XSA-163)
- x86/boot: check for not allowed sections before linking
- x86/ept: remove unnecessary sync after resolving misconfigured entries
- evtchn: don't reuse ports that are still "busy"
- VT-d: drop unneeded Ivybridge quirk workaround
- x86/time: fix domain type check in tsc_set_info()
- x86: don't leak ST(n)/XMMn values to domains first using them
  (CVE-2015-8555 / XSA-165)
- x86/HVM: avoid reading ioreq state more than once (XSA-166)
- net: pcnet: add check to validate receive data size
  (XSA-162 / CVE-2015-7504)
- MSI-X: avoid array overrun upon MSI-X table writes
  (XSA-164 / CVE pending)
- x86: make debug output consistent in hvm_set_callback_via
  (XSA-169 / CVE pending)

* Tue Dec 01 2015 neoclust <neoclust> 4.5.2-3.mga6
+ Revision: 907488
- Do not enable spice support on arm

* Tue Nov 10 2015 tmb <tmb> 4.5.2-2.mga6
+ Revision: 900407
- fix xsa156

* Wed Nov 04 2015 tmb <tmb> 4.5.2-1.mga6
+ Revision: 897747
- update to 4.5.2 (maintenance release)
  * drop merged xsa security fixes

* Fri Oct 30 2015 tmb <tmb> 4.5.1-2.mga6
+ Revision: 896795
- fix XSA145 - XSA153

* Wed Oct 14 2015 tmb <tmb> 4.5.1-1.mga6
+ Revision: 890554
- add missing xsa135 fixes to qemu-xen-traditional
- add fixes for xsa137-xsa142
- fix ixpe ath9k build with gcc 5.1+
- update to 4.5.1 (fixes XSA-117 to XSA-136)

* Fri Feb 20 2015 alien <alien> 4.5.0-4.mga5
+ Revision: 816020
- Fix virtio-9p support (shared folders)

* Thu Feb 19 2015 alien <alien> 4.5.0-3.mga5
+ Revision: 815803
- Fix service startup

* Thu Feb 19 2015 alien <alien> 4.5.0-2.mga5
+ Revision: 815785
- Add Spice support
- Fix seabios

* Mon Feb 02 2015 alien <alien> 4.5.0-1.mga5
+ Revision: 813108
- Update to version 4.5.0
- xend has now been removed
- remus has been integrated with xl
- add internal qemu translations
- include remus network buffering

* Tue Dec 02 2014 philippem <philippem> 4.4.1-5.mga5
+ Revision: 800394
- remove dependency on python-pyxml and change to python-lxml

* Wed Oct 15 2014 umeabot <umeabot> 4.4.1-4.mga5
+ Revision: 738855
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 4.4.1-3.mga5
+ Revision: 730736
- rebuild for missing pythoneggs deps

  + umeabot <umeabot>
    - Mageia 5 Mass Rebuild

* Sat Sep 06 2014 tv <tv> 4.4.1-1.mga5
+ Revision: 672956
- new release

  + pterjan <pterjan>
    - Rebuild for new Python

* Mon Mar 31 2014 tv <tv> 4.4.0-5.mga5
+ Revision: 610946
- readd back old ipxe tarball
  (we need to package edk2 + cross-binutils before packaging ipxe)
- add units files to file list
- install modules sysconfig file w/o executable permission
- add systemd units from FC
- further sync with FC
- sync stubdoms with FC
- drop old qemu-xen-4.0.0-rc4.tar.gz

* Mon Mar 31 2014 tv <tv> 4.4.0-4.mga5
+ Revision: 610826
- revert major bump for now (libification is wrong for quite some time with mixed majors)

* Mon Mar 31 2014 tv <tv> 4.4.0-3.mga5
+ Revision: 610820
- fix conflict with qemu

* Sun Mar 30 2014 tv <tv> 4.4.0-2.mga5
+ Revision: 610357
- bump major

* Sun Mar 30 2014 tv <tv> 4.4.0-1.mga5
+ Revision: 610096
- adjust file list
- new release

* Fri Nov 08 2013 alien <alien> 4.3.1-2.mga4
+ Revision: 550006
- Fix XSA-75(No CVE yet) - Host crash due to guest VMX instruction execution

* Sun Nov 03 2013 alien <alien> 4.3.1-1.mga4
+ Revision: 549232
- Update to version 4.3.1

* Fri Nov 01 2013 alien <alien> 4.3.0-7.mga4
+ Revision: 548766
- fix Security bug XSA73/No CVE yet - Lock order reversal between page allocation and grant table locks

* Tue Oct 29 2013 alien <alien> 4.3.0-6.mga4
+ Revision: 547869
- Security fix XSA72/CVE-2013-4416: ocaml xenstored mishandles oversized message replies

* Tue Oct 22 2013 umeabot <umeabot> 4.3.0-5.mga4
+ Revision: 544714
- Mageia 4 Mass Rebuild

* Tue Oct 15 2013 pterjan <pterjan> 4.3.0-4.mga4
+ Revision: 500002
- Rebuild to add different pythonegg provides for python 2 and 3

* Mon Oct 14 2013 alien <alien> 4.3.0-3.mga4
+ Revision: 497613
+ rebuild (emptylog)

* Mon Oct 14 2013 alien <alien> 4.3.0-2.mga4
+ Revision: 497500
- fix building in 32bit

* Mon Oct 14 2013 alien <alien> 4.3.0-1.mga4
+ Revision: 497469
- Exclude unsupported i586 hypervisor
- Fix building without fetcher
- Update to new version 4.3.0
- include polarssl for stubdom
- add xencov & xencov_split executables
- rediff xencommon patch
- remove upstreamed patches
- Fix XSA62,XSA63,XSA64,XSA66,XSA67,XSA68,XSA69,XSA70: CVE-2013-1442, CVE-2013-4355, CVE-2013-4356, CVE-2013-4361, CVE-2013-4368, CVE-2013-4369, CVE-2013-4370, CVE-2013-4371

* Wed Jun 12 2013 tv <tv> 4.2.2-1.mga4
+ Revision: 442161
- add man fix from FC
- new release
- drop merged patches
- drop useless gcc-4.5 support patch
- add security patches from FC

  + fwang <fwang>
    - rebuild for new brlapi

* Thu May 02 2013 alien <alien> 4.2.1-16.mga3
+ Revision: 412012
- Fix CVE-2013-1918 and CVE-2013-1952

* Thu Apr 18 2013 alien <alien> 4.2.1-15.mga3
+ Revision: 410438
- Fix CVE-2013-1917 & CVE-2013-1919

* Wed Apr 17 2013 alien <alien> 4.2.1-14.mga3
+ Revision: 410392
- Fix CVE-2013-1920
- Fix CVE-2012-5634, CVE-2013-0151, CVE-2013-0152, CVE-2013-0153, CVE-2013-0154 & CVE-2013-0215

* Tue Apr 09 2013 alien <alien> 4.2.1-12.mga3
+ Revision: 409145
- Fix libvirtd crash after shutdown guest

* Fri Apr 05 2013 alien <alien> 4.2.1-11.mga3
+ Revision: 408343
- fix missing requires

* Thu Apr 04 2013 alien <alien> 4.2.1-10.mga3
+ Revision: 407565
- fix and split ocaml packages

* Sat Mar 30 2013 tv <tv> 4.2.1-9.mga3
+ Revision: 406775
- patch 4: fix qemu-system-i386 path in xencommons service (mga#9294)

* Sun Mar 24 2013 colin <colin> 4.2.1-8.mga3
+ Revision: 404859
- Add systemd requires and general post/pre fixes (mga#9302)

* Sun Mar 03 2013 alien <alien> 4.2.1-7.mga3
+ Revision: 401283
- typo in filename
- helperscripts are only moved if different arch
- Move helper scripts to location they are looked after by various scripts and hardcoded binaries

* Sat Mar 02 2013 alien <alien> 4.2.1-6.mga3
+ Revision: 401170
- Fix creation of log directory

* Sat Mar 02 2013 alien <alien> 4.2.1-5.mga3
+ Revision: 401025
- Fix xenstored detection

* Wed Jan 16 2013 colin <colin> 4.2.1-4.mga3
+ Revision: 388627
- Use tmpfiles to create /run dirs.

* Mon Jan 14 2013 umeabot <umeabot> 4.2.1-3.mga3
+ Revision: 386743
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Jan 13 2013 alien <alien> 4.2.1-2.mga3
+ Revision: 361563
- Fix udev migration
- fix /run being tmpfs

* Tue Jan 08 2013 alien <alien> 4.2.1-1.mga3
+ Revision: 343172
- Update to new version

* Thu Aug 23 2012 guillomovitch <guillomovitch> 4.1.3-1.mga3
+ Revision: 283231
- new version

  + alien <alien>
    - add security patches

* Sun Jun 10 2012 tv <tv> 4.1.2-5.mga3
+ Revision: 259292
- require kmod instead of module-init-tools

* Mon Mar 26 2012 alien <alien> 4.1.2-4.mga2
+ Revision: 226967
- Fix for dom0 .xz compressed kernels

* Tue Mar 13 2012 guillomovitch <guillomovitch> 4.1.2-3.mga2
+ Revision: 223229
- debian patch for CVE-2012-0029

* Tue Mar 06 2012 malo <malo> 4.1.2-2.mga2
+ Revision: 219491
- rebuild for new vde
- rename xen-ocaml to ocaml-xen, per OCaml policy

* Wed Jan 25 2012 tmb <tmb> 4.1.2-1.mga2
+ Revision: 201370
- update to 4.1.2
- kernel-xen-pvops is now merged with kernel-server
- drop defattr

* Thu Nov 03 2011 dmorgan <dmorgan> 4.1.1-2.mga2
+ Revision: 161928
- Change tetex-texi2html into texi2html

  + fwang <fwang>
    - drop invalid Default-Enabled keyword
    - br gcrypt

  + tv <tv>
    - new release

* Mon Apr 11 2011 tmb <tmb> 4.1.0-2.mga1
+ Revision: 83471
- rebuild for missing x86_64 packages

* Sun Apr 10 2011 tmb <tmb> 4.1.0-1.mga1
+ Revision: 83034
- update to 4.1.0
- add ipxe sources
- require kernel-xen-pvops

* Mon Mar 07 2011 saispo <saispo> 4.0.1-1.mga1
+ Revision: 65925
- imported package xen

